## glslviewer 1.5

=== Makefile ===
EXE = ./bin/glslViewer

CXX = g++
SOURCES := $(wildcard include/*/*.cc) $(wildcard src/*.cpp) $(wildcard src/*/*.cpp)
HEADERS := $(wildcard include/*/*.h) $(wildcard src/*.h) $(wildcard src/*.h) $(wildcard src/*/*.h)
OBJECTS := $(SOURCES:.cpp=.o)

PLATFORM = $(shell uname)
ifneq ("$(wildcard /etc/os-release)","")
PLATFORM = $(shell . /etc/os-release && echo $$NAME)
endif

#override platform selection on RPi:
ifneq ("$(wildcard /opt/vc/include/bcm_host.h)","")
    PLATFORM = $(shell . /etc/os-release && echo $$PRETTY_NAME)
endif

#$(info Platform ${PLATFORM})

INCLUDES +=	-Isrc/ -Iinclude/
CFLAGS += -Wall -O3 -std=c++11 -fpermissive

ifeq ($(PLATFORM),Raspbian GNU/Linux 8 (jessie))
CFLAGS += -DGLM_FORCE_CXX98 -DPLATFORM_RPI
INCLUDES += -I$(SDKSTAGE)/opt/vc/include/ \
			-I$(SDKSTAGE)/opt/vc/include/interface/vcos/pthreads \
			-I$(SDKSTAGE)/opt/vc/include/interface/vmcs_host/linux
LDFLAGS += -L$(SDKSTAGE)/opt/vc/lib/ \
			-lGLESv2 -lEGL \
			-lbcm_host \
			-lpthread

else ifeq ($(PLATFORM),Raspbian GNU/Linux 9 (stretch))
	CFLAGS += -DGLM_FORCE_CXX98 -DPLATFORM_RPI
	INCLUDES += -I$(SDKSTAGE)/opt/vc/include/ \
				-I$(SDKSTAGE)/opt/vc/include/interface/vcos/pthreads \
				-I$(SDKSTAGE)/opt/vc/include/interface/vmcs_host/linux
	LDFLAGS += -L$(SDKSTAGE)/opt/vc/lib/ \
			   	-lbrcmGLESv2 -lbrcmEGL \
			   	-lbcm_host \
			    -lpthread
$(info Platform ${PLATFORM})

else ifeq ($(shell uname),Linux)
CFLAGS += -DPLATFORM_LINUX $(shell pkg-config --cflags glfw3 glu gl)
LDFLAGS += $(shell pkg-config --libs glfw3 glu gl x11 xrandr xi xxf86vm xcursor xinerama xrender xext xdamage) -lpthread -ldl

else ifeq ($(PLATFORM),Darwin)
CXX = /usr/bin/clang++
ARCH = -arch x86_64
CFLAGS += $(ARCH) -DPLATFORM_OSX -stdlib=libc++ $(shell pkg-config --cflags glfw3)
INCLUDES += -I/Library/Frameworks/GLUI.framework
LDFLAGS += $(ARCH) -framework OpenGL -framework Cocoa -framework CoreVideo -framework IOKit $(shell pkg-config --libs glfw3)

endif

all: $(EXE)

%.o: %.cpp
	@echo $@
	$(CXX) $(CFLAGS) $(INCLUDES) -g -c $< -o $@ -Wno-deprecated-declarations

$(EXE): $(OBJECTS) $(HEADERS)
	$(CXX) $(CFLAGS) $(OBJECTS) $(LDFLAGS) -rdynamic -o $@

clean:
	@rm -rvf $(EXE) src/*.o src/*/*.o include/*/*.o *.dSYM

install:
	@cp $(EXE) /usr/local/bin
	@cp bin/glslLoader /usr/local/bin

uninstall:
	@rm /usr/local/$(EXE)
	@rm /usr/local/bin/glslLoader

=== debian/changelog ===
glslviewer (1.5) UNRELEASED; urgency=medium

  * Adding `frag`/`vert` console commands to print fragment/vertex source code

  * Adding -v/--verbose arguments

  * Adding --help argument

  * Changing -m argument for -c/--cursor

  * Compilation time now only shows on -v/--verbose mode

  * COUTs print w '//' at the beginning in case someone wants to use the output directly as source code


 -- Patricio Gonzalez Vivo <patricio@ubuntu>  Sun, 26 Nov 2017 02:45:12 -0800

glslviewer (1.3) UNRELEASED; urgency=medium

  * Adding console gcc-like precompiler arguments to satisfy GLSL shaders dependencies -I[dir] -D[define]

  * Adding 'screenshot' command on CIN to save screenshots to other files rather than the specified on -o [file]

  * Adding travis and editorconfig files to help others contribute

  * General housekeeping of utils functions. Now they are split in tools/fs tools/text and tools/geom 
  * 

 -- Patricio Gonzalez Vivo <patricio@ubuntu>  Wed, 16 Aug 2017 03:20:21 -0800

glslviewer (1.2) UNRELEASED; urgency=medium

  * Better Makefile: Using Broadcom SDK when is possible not... only on Raspberry Pi

  * Upgrading GLM to 0.9.8.4

  * Upgrading stb_image to 2.14

  * Upgrading stb_image_write to 1.03

  * Fixing and improving pixelDensity changes

  * Compatibility with ShaderToy Image Shaders (@doug-moen)

  * Verbose comments on compiling time and improvements on warnings and errors (@doug-moen)

  * Headless support

  * fixing recursive #include system

  * console outs for time, delta and fps on demand

 -- Patricio Gonzalez Vivo <patricio@ubuntu>  Tue, 21 Feb 2017 14:20:28 -0500

glslviewer (1.1) unstable; urgency=low

  * Initial Release.

 -- Patricio Gonzalez Vivo <patriciogonzalezvivo@gmail.com>  Thu, 29 Sep 2016 06:43:54 -0400

=== debian/control ===
Source: glslviewer
Section: unknown
Priority: optional
Maintainer: Patricio Gonzalez Vivo <patriciogonzalezvivo@gmail.com>
Build-Depends: debhelper (>=9), pkg-config, libglfw3-dev, libglu1-mesa-dev, libxrandr-dev,
 libxi-dev, libxcursor-dev, libxinerama-dev
Standards-Version: 3.9.6
Homepage: https://github.com/patriciogonzalezvivo/glslViewer

Package: glslviewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GLSL Shader Visualizer
 This is a GLSL live-coding console tool that renders GLSL Shaders. Every file you use (frag/vert shader, images and geometries) is watched for modification, and every time you modify it GlslViewer will automatically update their content. This tools is consistent with the scheam of uniforms described on The Book of Shaders (http://thebookofshaders.com) and it on-line editor (http://editor.thebookofshaders.com) that is why this is a great tool to learn how to code your own shaders.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autotools-dev

override_dh_auto_install:
	install -D -m 0755 bin/glslViewer $$(pwd)/debian/glslviewer/usr/bin/glslViewer
	install -D -m 0755 bin/glslLoader $$(pwd)/debian/glslviewer/usr/bin/glslLoader
